/// \file example.cc
/// \author Егор Старобинский
/// \date 26 ноября 2018
/// \brief Пример документирования для занятий по Linux
/// \details Это тестовый пример документирования функций C++ для курса
/// программирования в Linux, позволяющий генерировать  ПД с помощью программы
/// Doxygen.
/// \see http://tm.spbstu.ru/Программирование_в_Linux
/// \see http://www.doxygen.nl

#include <iostream>

/// \defgroup MathFunctions Группа математических функций на C++
/// \brief Математические функции на C++
/// \details Группа содержит простые математические функции на C++
/// \{

/// \brief Эта функция складывает два числа
/// \details Эта функция складывает два числа, если это возможно, и возвращает
/// результат
/// \param a Первое слагаемое
/// \param b Второе слагаемое
/// \return Сумма двух чисел
/// \tparam T Числовой тип
template<typename T>
T add(T a, T b){
    return a + b;
}

/// \brief Эта функция находит разность двух чисел
/// \details Эта функция вычитает из числа другое число с помощью функции
/// add(), если это возможно, и возвращает результат
/// \param a Уменьшаемое
/// \param b Вычитаемое
/// \return Разность двух чисел
/// \tparam T Числовой тип
/// \todo Реализовать метод без привязки к функции add()
template<typename T>
T substract(T a, T b){
    return add(a, -b);
}

/// \} Окончание группы математических функций

/// \brief Main-функция на C++
/// \details Эта функция запускает вычисления на C++
int main(int argc, char const *argv[]){
    std::cout << "Hello" << std::endl;
    
    double a = 1.75684392;
    double b = 643.3245;
    
    std::cout << add(a, b) << std::endl;
    std::cout << substract(a, b) << std::endl;
    
    return 0;
}