#!/usr/bin/env python
# -*- coding: utf-8 -*-

## \file example.cc
## \package example
## \author Егор Старобинский
## \date 26 ноября 2018
## \brief Пример документирования для занятий по Linux
## \details Это тестовый пример документирования функций Python для курса
## программирования в Linux, позволяющий генерировать  ПД с помощью программы
## Doxygen.
## \see http://tm.spbstu.ru/Программирование_в_Linux
## \see http://www.doxygen.nl

import io

## \defgroup MathFunctionsPython Группа математических функций на Python
## \brief Математические функции на Python
## \details Группа содержит простые математические функции на Python
## \{

## \brief Эта функция перемножает два числа
## \details Эта функция перемножает два числа, если это возможно, и возвращает
## результат
## \param a Первый множитель
## \param b Второй множитель
## \return Произведение двух чисел
def multiply(a, b):
    return a * b;

## \brief Эта функция находит отношение двух чисел
## \details Эта функция делитчисло на другое число с помощью функции
## multiply(), если это возможно, и возвращает результат
## \param a Делимое
## \param b Делитель
## \return Частное двух чисел
## \tparam T Числовой тип
## \todo Реализовать метод без привязки к функции multiply()
def divide(a, b):
    return multiply(a, 1. / b)

## \} Окончание группы математических функций

## \brief Main-функция на Python
## \details Эта функция запускает вычисления на Python
def mainPython():
    print("Hello");
    
    a = 1.75684392
    b = 643.3245
    
    print(multiply(a, b))
    print(divide(a, b))

mainPython()